/* ------------------------------------------------------------------------
 *
 * Copyright 2006 by zelon
 *
 * LockUtil.h
 *
 * 2006. 3. 11 Jinwook Kim
 *
 * ------------------------------------------------------------------------
 */


#pragma once

#include <windows.h>

///  Event    ϴ ƿƼ Ŭ
class CEventObj
{
public:
	CEventObj()
	{
		m_hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	}

	~CEventObj()
	{
		CloseHandle(m_hEvent);
	}

	bool setEvent()
	{
		return SetEvent(m_hEvent) == TRUE;
	}

	DWORD wait()
	{
		return WaitForSingleObject(m_hEvent, INFINITE);
	}

protected:
	///   ִ ̺Ʈ ڵ
	HANDLE m_hEvent;

};

///  ũƼ    ϴ ƿƼ Ŭ
class CLockObj
{
public:
	CLockObj()
	{
		InitializeCriticalSection(&m_cs);
	}

	~CLockObj()
	{
		DeleteCriticalSection(&m_cs);
	}

protected:
	///   ִ ũƼ 
	CRITICAL_SECTION m_cs;


private:

	friend class CLockObjUtil;

	inline void lock()
	{
		EnterCriticalSection(&m_cs);
	}

	inline void unlock()
	{
		LeaveCriticalSection(&m_cs);
	}


};

/// lock, unlock   ϱ  ִ ƿƼ Ŭ
class CLockObjUtil
{
public:
	CLockObjUtil(CLockObj & lockObj)
		: m_lockObj(lockObj)
	{
		lockObj.lock();
	}

	~CLockObjUtil()
	{
		m_lockObj.unlock();
	}

protected:
	/// ڿ  ũƼ    ִ  
	CLockObj & m_lockObj;
};

